VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Send File"
   ClientHeight    =   2130
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9090
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   142
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   606
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtRemotePort 
      Height          =   285
      Left            =   1800
      MaxLength       =   5
      TabIndex        =   10
      Text            =   "8866"
      Top             =   900
      Width           =   1095
   End
   Begin VB.TextBox txtRemoteCon 
      Height          =   285
      Left            =   1800
      MaxLength       =   128
      TabIndex        =   9
      Text            =   "localhost"
      Top             =   540
      Width           =   2895
   End
   Begin VB.Timer tmrCalcSpeed 
      Interval        =   1000
      Left            =   2475
      Top             =   45
   End
   Begin VB.Timer tmrSendFile 
      Enabled         =   0   'False
      Left            =   1980
      Top             =   45
   End
   Begin MSWinsockLib.Winsock SckSendFile 
      Left            =   1530
      Top             =   45
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin MSComDlg.CommonDialog CDialog 
      Left            =   4635
      Top             =   45
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
   End
   Begin VB.PictureBox picProgress 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      FillColor       =   &H00C00000&
      ForeColor       =   &H80000008&
      Height          =   285
      Left            =   180
      ScaleHeight     =   255
      ScaleWidth      =   8715
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   1710
      Width           =   8745
   End
   Begin VB.CommandButton cmdSendFile 
      Caption         =   "&Send File"
      Height          =   645
      Left            =   7245
      TabIndex        =   2
      Top             =   585
      Width           =   1680
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "&Browse"
      Height          =   330
      Left            =   7245
      TabIndex        =   1
      Top             =   105
      Width           =   1680
   End
   Begin VB.TextBox txtFileName 
      Height          =   285
      Left            =   1035
      Locked          =   -1  'True
      TabIndex        =   0
      Top             =   135
      Width           =   6090
   End
   Begin VB.Label lblSendSpeed 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "0.00 Kb/Sec"
      Height          =   195
      Left            =   7965
      TabIndex        =   11
      Top             =   1485
      Width           =   915
   End
   Begin VB.Line Line2 
      X1              =   12
      X2              =   594
      Y1              =   89
      Y2              =   89
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00FFFFFF&
      X1              =   12
      X2              =   594
      Y1              =   90
      Y2              =   90
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Remote Port:"
      Height          =   195
      Left            =   180
      TabIndex        =   8
      Top             =   900
      Width           =   930
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Remote Connection:"
      Height          =   195
      Left            =   180
      TabIndex        =   7
      Top             =   585
      Width           =   1455
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "File Name:"
      Height          =   195
      Left            =   180
      TabIndex        =   6
      Top             =   180
      Width           =   750
   End
   Begin VB.Label lblProgress 
      AutoSize        =   -1  'True
      Caption         =   "0.0% Sent"
      Height          =   195
      Left            =   1215
      TabIndex        =   5
      Top             =   1485
      Width           =   720
   End
   Begin VB.Label lblFileToSend 
      AutoSize        =   -1  'True
      Caption         =   "Sending File:"
      Height          =   195
      Left            =   180
      TabIndex        =   4
      Top             =   1485
      Width           =   915
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Made By Michael Ciurescu (CVMichael from vbforums.com)

Private Const PacketSize As Long = 1024 * 4

Private sFileName As String
Private iFileNum As Integer

Private Sub cmdBrowse_Click()
    On Error GoTo ErrCancel
    CDialog.ShowOpen
    
    txtFileName.Text = CDialog.FileName
    txtFileName.SelStart = Len(txtFileName.Text)
    
    Exit Sub
ErrCancel:
    If Err.Number = 32755 Then
        Exit Sub
    Else
        MsgBox "Error# " & Err.Number & vbNewLine & "Description: " & Err.Description, vbExclamation
    End If
End Sub

Private Sub PicShowPercentage(pic As PictureBox, ByVal Percentage As Single, Optional ByVal ForeColor As Long = -2, Optional ByVal BackColor As Long = -2)
    If ForeColor = -2 Then ForeColor = pic.ForeColor
    If BackColor = -2 Then BackColor = pic.BackColor
    
    pic.Line (0, 0)-(pic.ScaleWidth * Percentage, pic.ScaleHeight), ForeColor, BF
    pic.Line (pic.ScaleWidth * Percentage, pic.ScaleHeight)-(pic.ScaleWidth, 0), BackColor, BF
End Sub

Private Sub cmdSendFile_Click()
    If cmdSendFile.Caption = "&Send File" Then
        If Len(txtFileName.Text) > 0 Then
            If Len(Dir(txtFileName.Text, vbNormal + vbArchive)) > 0 Then
                cmdSendFile.Caption = "&Cancel Sending..."
                
                SendFile txtFileName.Text
            End If
        End If
    Else
        SckSendFile_Close
        cmdSendFile.Caption = "&Send File"
    End If
End Sub

Private Sub SendFile(ByVal FileName As String)
    tmrSendFile.Enabled = False
    
    SckSendFile.Close
    DoEvents
    
    SckSendFile.RemoteHost = Me.txtRemoteCon.Text
    SckSendFile.RemotePort = Val(Me.txtRemotePort.Text)
    SckSendFile.Connect
    
    sFileName = FileName
End Sub

Private Sub SckSendFile_Close()
    tmrSendFile.Enabled = False
    tmrSendFile.Interval = 0
    
    Close iFileNum ' close file
    iFileNum = 0 ' set file number to 0, timer will exit if another timer event
    
    SckSendFile.Close
    
    cmdSendFile.Caption = "&Send File"
    PicShowPercentage Me.picProgress, 0
    lblProgress.Caption = "0.00% Done"
End Sub

Private Sub SckSendFile_Connect()
    Dim Buffer() As Byte, P As Long
    
    iFileNum = FreeFile
    Open sFileName For Binary Access Read Lock Write As iFileNum
    
    ReDim Buffer(lngMIN(LOF(iFileNum), PacketSize) - 1)
    Get iFileNum, , Buffer ' read data
    
    SckSendFile.SendData CStr(LOF(iFileNum)) & ","   ' send the file size
    P = InStrRev(sFileName, "\")
    SckSendFile.SendData Mid(sFileName, P + 1) & ":" ' send the file name
    SckSendFile.SendData Buffer                      ' send first packet
End Sub

Private Sub SckSendFile_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    SckSendFile_Close
End Sub

Private Sub SckSendFile_SendComplete()
    ' can't call SendData here, so enable timer to do it...
    tmrSendFile.Enabled = False
    tmrSendFile.Interval = 1
    tmrSendFile.Enabled = True
End Sub

Private Sub tmrCalcSpeed_Timer()
    Static PrevSent As Long
    Dim BSentPerSec As Long, DataSent As Long, DataLen As Long
    Dim SecondsLeft As Single
    
    If iFileNum > 0 Then
        DataSent = Loc(iFileNum)
        DataLen = LOF(iFileNum)
        
        BSentPerSec = DataSent - PrevSent
        PrevSent = DataSent
        
        SecondsLeft = (CSng(DataLen) - CSng(DataSent)) / CSng(BSentPerSec)
    Else
        PrevSent = 0
    End If
    
    lblSendSpeed.Caption = Format(DataSent / 1024#, "###,###,##0.00") & " KBytes Sent, " & _
        Format(CDbl(BSentPerSec) / 1024#, "#0.00") & " Kb/Sec, " & _
        "Time left: " & Format(SecondsLeft \ 3600, "00") & ":" & Format(SecondsLeft \ 60, "00") & ":" & Format(SecondsLeft Mod 60, "00")
End Sub

Private Sub tmrSendFile_Timer()
    Dim Buffer() As Byte, BuffSize As Long
    
    tmrSendFile.Enabled = False
    If iFileNum <= 0 Or SckSendFile.State <> sckConnected Then Exit Sub
    
    If Loc(iFileNum) >= LOF(iFileNum) Then ' FILE COMPLETE
        Close iFileNum ' close file
        iFileNum = 0 ' set file number to 0, timer will exit if another timer event
        
        Exit Sub
    End If
    
    'if the remaining size in the file is smaller then PacketSize, the read only whatever is left
    BuffSize = lngMIN(LOF(iFileNum) - Loc(iFileNum), PacketSize)
    
    ReDim Buffer(BuffSize - 1) ' resize buffer
    Get iFileNum, , Buffer ' read data
    SckSendFile.SendData Buffer ' send data
    
    ' Show progress
    lblProgress.Caption = Format(Loc(iFileNum) / CDbl(LOF(iFileNum)), "Percent") & " Done"
    PicShowPercentage picProgress, Loc(iFileNum) / CDbl(LOF(iFileNum))
End Sub

Private Sub txtRemotePort_Validate(Cancel As Boolean)
    txtRemotePort.Text = Val(txtRemotePort.Text)
End Sub

Public Function lngMIN(ByVal L1 As Long, ByVal L2 As Long) As Long
    If L1 < L2 Then
        lngMIN = L1
    Else
        lngMIN = L2
    End If
End Function
